--  Base types for PSL.
--  Copyright (C) 2019 Tristan Gingold
--
--  GHDL is free software; you can redistribute it and/or modify it under
--  the terms of the GNU General Public License as published by the Free
--  Software Foundation; either version 2, or (at your option) any later
--  version.
--
--  GHDL is distributed in the hope that it will be useful, but WITHOUT ANY
--  WARRANTY; without even the implied warranty of MERCHANTABILITY or
--  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
--  for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with GHDL; see the file COPYING.  If not, write to the Free
--  Software Foundation, 59 Temple Place - Suite 330, Boston, MA
--  02111-1307, USA.
with PSL.Nodes_Priv;

package PSL.Types is
   --  PSL Node.
   subtype PSL_Node is PSL.Nodes_Priv.PSL_Node;
   function "=" (L, R : PSL_Node) return Boolean
     renames PSL.Nodes_Priv."=";
   Null_PSL_Node : constant PSL_Node := PSL.Nodes_Priv.Null_PSL_Node;

   --  PSL NFA
   subtype PSL_NFA is PSL.Nodes_Priv.PSL_NFA;
   function "=" (L, R : PSL_NFA) return Boolean
     renames PSL.Nodes_Priv."=";
end PSL.Types;
